﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using System.Net;
using System.IO;

namespace pdaGIFIISettings
{
    public partial class Form1 : Form
    {
        static private string strRegistrySubkey = "\\SOFTWARE\\GPSInstantFixII";
        static private string strRegistryKey = Registry.LocalMachine + strRegistrySubkey;
        static private string strDebugLogFile = "\\sirf_debug.txt";
        static private string strGPSStorageFile = "\\NVM3";

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            textBox1.Text = (string)Registry.GetValue(strRegistryKey, "EEFilename", "NVM5.ee");
            textBox2.Text = (string)Registry.GetValue(strRegistryKey, "EEPath", "\\Program Files\\GPSInstantFixII");

            textBox4.Text = (string)Registry.GetValue(strRegistryKey, "EETimeStamp", "(Не определено)");

            try
            {
                DateTime dateTime = DateTime.Parse(textBox4.Text);
                textBox4.Text = dateTime.ToLongDateString();
            }
            catch (Exception ex)
            {
            }

            textBox5.Text = (string)Registry.GetValue(strRegistryKey, "Version", "(Версия прошивки чипа GPS не определена)");
            textBox6.Text = (string)Registry.GetValue(strRegistryKey, "CLM", "(Версия CLM не определена)");

            checkBox1.CheckState = (CheckState)Registry.GetValue(strRegistryKey, "EnableEE", CheckState.Unchecked);
            checkBox2.CheckState = (CheckState)Registry.GetValue(strRegistryKey, "EnableWAAS", CheckState.Unchecked);
            checkBox3.CheckState = (CheckState)Registry.GetValue(strRegistryKey, "Diagnostic", CheckState.Unchecked);
            
            if (Registry.GetValue(strRegistryKey, "Clear_EE", null) != null) checkBox4.CheckState = CheckState.Checked;
            else checkBox4.CheckState = CheckState.Unchecked;
            
            string[] strEEFileStatus = { "(Не определено)", "Не используется", "Актуален", "Не актуален" };
            textBox3.Text = strEEFileStatus[(int)Registry.GetValue(strRegistryKey, "EEStatus", -1) + 1];

            numericUpDown1.Value = (int)Registry.GetValue(strRegistryKey, "CLM_Log_Level", 0);

            if (File.Exists(strGPSStorageFile)) textBox10.Text = File.GetLastWriteTime(strGPSStorageFile).ToLongDateString();
            else textBox10.Text = "(Не определено)";
        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            Registry.SetValue(strRegistryKey, "EEFileName", textBox1.Text);
            Registry.SetValue(strRegistryKey, "EEPath", textBox2.Text);

            Registry.SetValue(strRegistryKey, "EnableEE", (int)checkBox1.CheckState);
            Registry.SetValue(strRegistryKey, "EnableWAAS", (int)checkBox2.CheckState);
            Registry.SetValue(strRegistryKey, "Diagnostic", (int)checkBox3.CheckState);

            if (checkBox4.CheckState == CheckState.Checked) Registry.SetValue(strRegistryKey, "Clear_EE", 1);
            else if (Registry.GetValue(strRegistryKey, "Clear_EE", null) != null) Registry.LocalMachine.OpenSubKey(strRegistrySubkey, true).DeleteValue("Clear_EE");

            Registry.SetValue(strRegistryKey, "CLM_Log_Level", (int)numericUpDown1.Value);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            button2.Enabled = false;

            listBox1.Items.Clear();

            try
            {
                if (File.Exists(strDebugLogFile))
                {
                    StreamReader streamReader = File.OpenText(strDebugLogFile);

                    while (!streamReader.EndOfStream)
                    {
                        listBox1.Items.Add(streamReader.ReadLine());
                    }

                    streamReader.Close();

                    button3.Enabled = true;
                }
                else
                {                
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
            }

            button2.Enabled = true;
        }

        private void DownloadFile(string url, string fileName)
        {
            progressBar1.Value = 0;

            Uri uri = new Uri(url);
            HttpWebRequest httpWebRequest = (HttpWebRequest)HttpWebRequest.Create(uri);

            try
            {
                HttpWebResponse httpWebResponse = (HttpWebResponse)httpWebRequest.GetResponse();

                using (BinaryReader binaryReader = new BinaryReader(httpWebResponse.GetResponseStream()))
                {
                    progressBar1.Maximum = (int)httpWebResponse.ContentLength;

                    FileStream fileStream = File.OpenWrite(fileName);

                    byte[] fileBytes = new byte[1024];

                    while (progressBar1.Value < progressBar1.Maximum)
                    {
                        int bytesRead = 0;

                        bytesRead = binaryReader.Read(fileBytes, 0, fileBytes.Length);
                        if (bytesRead > 0)
                        {
                            fileStream.Write(fileBytes, 0, bytesRead);

                            progressBar1.Value += bytesRead;
                        }
                    }

                    progressBar1.Value = progressBar1.Maximum;

                    fileStream.Close();
                }

                httpWebResponse.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            button1.Enabled = false;
            
            DownloadFile(textBox7.Text, textBox2.Text + "\\" + textBox1.Text);

            button1.Enabled = true;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            button3.Enabled = false;

            listBox1.Items.Clear();

            if (File.Exists(strDebugLogFile)) File.Delete(strDebugLogFile);
        }
    }
}
